//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:display.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"dot8x8_h.h"
#include	"display_h.h"

//*****************************************
// Pabc̕\
//@F\JniOFŏʁAPSFŉʁj
//@FPabc̒l(D0--D3)
//*****************************************
void	disp_dot8x8_one(unsigned char n,unsigned char bcd)
{
	disp_dot8x8_number(n, bcd & 0x0f);
}
//*****************************************
// Qabc̕\
//@F\JniOFŏʁAPSFŉʁj
//@FQabc̒l
//*****************************************
void	disp_dot8x8_tow(unsigned char n,unsigned char bcd)
{
	disp_dot8x8_number(n+0, bcd >> 4);		// 
	disp_dot8x8_number(n+1, bcd & 0x0f);	// 
}
//*****************************************
//  Qabc̕\
//*****************************************
void	disp_dot8x8_tow_h(unsigned char bcd)
{
	disp_dot8x8_tow(0, bcd);				// Qabc̕\
}
//*****************************************
//  Qabc̕\
//*****************************************
void	disp_dot8x8_tow_m(unsigned char bcd)
{
	disp_dot8x8_tow(2, bcd);				// Qabc̕\
}
//*****************************************
//  Qabc̕\
//*****************************************
void	disp_dot8x8_tow_l(unsigned char bcd)
{
	disp_dot8x8_tow(4, bcd);				// Qabc̕\
}
//*****************************************
// Sabc̕\
//*****************************************
void	disp_dot8x8_four(unsigned char bcd_h, unsigned char bcd_l)
{
	disp_dot8x8_tow(0, bcd_h);				// Qabc̕\
	disp_dot8x8_tow(2, bcd_l);				// Qabc̕\
}
//*****************************************
// Uabc̕\
//*****************************************
void	disp_dot8x8_six(unsigned char bcd_h, unsigned char bcd_m, unsigned char bcd_l)
{
	disp_dot8x8_tow(0, bcd_h);				// Qabc̕\
	disp_dot8x8_tow(2, bcd_m);				// Qabc̕\
	disp_dot8x8_tow(4, bcd_l);				// Qabc̕\
}
//*****************************************
// S\iXXXX܂Łj
//@F\JniOFŏʁAPSFŉʁj
//*****************************************
void	disp_dot8x8_4binary(unsigned char n,unsigned short us)
{
	if(9999 < us){
		us = 9999;
	}
	disp_dot8x8_number(n+0, us/1000);		// 
	disp_dot8x8_number(n+1, (us%1000)/100);	// 2
	disp_dot8x8_number(n+2, (us%100)/10);	// 3
	disp_dot8x8_number(n+3, us%10);			// 

}
