//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:dot8x8.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************

#include	<avr/pgmspace.h>
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"uart_h.h"
#include	"dot8x8_h.h"


static	unsigned char	dot8x8_data[KETA_SEL_MAX+3];			// \{bq{ke{O

//******************************
//  8x8 dot\@
// *****************************
void	init_dot8x8(void)
{
	unsigned char	uc;

// \AR f[^
	for(uc = 0;uc < KETA_SEL_MAX; uc++){
		dot8x8_data[uc] = '=';		// \NA
	}

	dot8x8_data[0] = 'Q';		// Q
	dot8x8_data[1] = 'R';		// R
	dot8x8_data[2] = 'S';		// S
	dot8x8_data[3] = 'T';		// T
	dot8x8_data[4] = 'U';		// U
	dot8x8_data[5] = 'V';		// V
	dot8x8_data[6] = 'W';		// W
	dot8x8_data[7] = 'X';		// X
	dot8x8_data[8] = 'Y';		// Y
	dot8x8_data[9] = 'Z';		// Z

	dot8x8_data[10] = '\r';		// CR
	dot8x8_data[11] = '\n';		// LF
	dot8x8_data[12] = 0x00;		// 0

	uart_init();				// UART ݒ

}

//******************************
// WW \
//  k : ʒuiO`XAOFŏʁEEEXFŉʁj
//   : OOO`O
// *****************************
void	disp_dot8x8_moji(unsigned char k, unsigned char m)
{
	if(k < KETA_MAX){							// IlȎ
		dot8x8_data[k] = m;
	}else{										// IlُȎ
			;									// ȂɂȂ
	}
}

//******************************
// WW \
//  k : ʒuiO`XAOFŏʁEEEXFŉʁj
//  n : O`XAPTiPT͋󔒁j
// *****************************
void	disp_dot8x8_number(unsigned char k, unsigned char n)
{
	if(k < KETA_MAX){							// IlȎ
		if((0 <= n) && ( n <= 9)){				// lȎ
			dot8x8_data[k] = (n + 0x30);
		}else{									// lُȎ
			dot8x8_data[k] = 0x20;				// 󔒂ɂ
		}
	}else{										// IlُȎ
			;									// ȂɂȂ
	}
}


//******************************
// WW \S
// *****************************
void	disp_dot8x8_clear(void)
{
	unsigned char uc;

	for(uc=0;uc < KETA_MAX; uc++){
		disp_dot8x8_number(uc, 15);				//   
	}
}

//******************************
// WW S\
// *****************************
void	disp_dot8x8_all(void)
{

	uart_tx_str((char *)(&dot8x8_data[0]));

}

