//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"port_bit_h.h"
#include	"timer_h.h"
#include	"dot8x8_h.h"
#include	"uart_h.h"
#include	"eep_dat_h.h"

uint16_t	eep_bps_600 EEMEM = BPS_600;			// UOOaor̒l
uint16_t	eep_bps_9600 EEMEM = BPS_9600;			// XUOOaor̒l
static	unsigned short	eep_bfs[10];

//*****************************************
//@ddoqnl BPS_600 ǂݍ
//*****************************************
unsigned short	read_eep_bps_600(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_word(&eep_bps_600);		// Ǐo
	if((800 <= eep_bfs[0])&&(eep_bfs[0] <= 900)){
		r = eep_bfs[0];
	}else{
		r = BPS_600;
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS_9600 ǂݍ
//*****************************************
unsigned short	read_eep_bps_9600(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_word(&eep_bps_9600);		// Ǐo
	if(((BPS_9600-2) <= eep_bfs[0])&&(eep_bfs[0] <= (BPS_9600+5))){
		r = eep_bfs[0];
	}else{
		r = BPS_9600;
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS_600 
//*****************************************
void	write_eep_bps_600(unsigned short us)
{
	eep_bfs[0] = us;
	eeprom_busy_wait();
	eeprom_write_word(&eep_bps_600, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnl BPS_9600 
//*****************************************
void	write_eep_bps_9600(unsigned short us)
{
	eep_bfs[0] = us;
	eeprom_busy_wait();
	eeprom_write_word(&eep_bps_9600, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

