//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   UWlgɂ

// File Name:gps_clock.c
//
//
//  2022/09/10 New TAB4 Taishi
//  2023/02/25 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"display_h.h"
#include	"uart_h.h"
#include	"infrared_h.h"
#include	"gps_clock_h.h"


#define	GPS_RX_NUMBER_MAX		128				// for@Mf[^̐
unsigned char			Ggps_data;				// Mf[^ifobOpj
unsigned char			gGPS_active = 0;
unsigned char			gGPS_data_valid = 0;	// 0:invalid, 1=valid
unsigned char			gGPS_sec;				// for b̃f[^ (BCD 0--59)
unsigned char			gGPS_min;				// for ̃f[^ (BCD 0--59)
unsigned char			gGPS_hou;				// for ̃f[^ (BCD 0--23j
unsigned char			gGPS_day;				// for ̃f[^ (BCD 1--31)
unsigned char			gGPS_mon;				// for ̃f[^ (BCD 1--12j
unsigned char			gGPS_year;				// for Ñf[^ (BCD 0--99)
static	unsigned char	gps_rx_data[GPS_RX_NUMBER_MAX+1];	// forMf[^鏊
static	unsigned char	gps_rx_number = 0;					// forMf[^ԍ
static	unsigned char	temp_str[128];			// ėp̕鏊

// *********************************************************
// cF[̌
//  FN 
// @@ F
// @@ F
// ߂l@jFOjAPjADDDDUyj
// *********************************************************
unsigned char subZeller( unsigned short y, unsigned short m, unsigned short d )
{
	unsigned char	r;
	
    if( m < 3 ) {
        y--;
		m += 12;
    }
    r = (unsigned char)(( y + y/4 - y/100 + y/400 + ( 13*m + 8 )/5 + d )%7);
    return(r);
}


//*****************************************
// forv Initial
//  荞ݕs̏ԂŌĂ΂Ƃ
//
//*****************************************
void	gps_clock_init(void)
{
	unsigned char	uc;

// *********** RXD0 Bit ***********
	DDRD &= ~((1 << DDD0));		// Port-D Bit0 : Intput
	PORTD |= ((1 << PD0) );		// Port-D Bit0 : Pullup

// *********** TXD0 Bit ***********
	PORTD |= ((1 << PD1) );		// Port-D Bit1 : Hi
	DDRD |= (1 << DDD1);		// Port-D Bit1 : Output

	for(uc = 0; uc < GPS_RX_NUMBER_MAX; uc++){
		gps_rx_data[uc] = 0;	// forMf[^鏊
	}
	gps_rx_number = 0;			// forMf[^ԍ

	uart_init();				// UART0 ݒ
}

//***************************
// for PbMݐݒ
// GPS 1Sec sig intrrupt INT1
//***************************
void	gps_1sec_init(void)
{

	// INT1 Port Initial
	DDRD &= ~(1 << DDD3);		// Port-D Bit3 : Intput
	PORTD |= (1 << PD3);		// PD3 Pullup

	// INT1 Interrupt Initial
	EICRA |=  (1 << ISC11);		// INT1 Falling Edge Interrupt
	EICRA &= ~(1 << ISC10);		// INT1 Falling Edge Interrupt
	EIMSK |= (1 << INT1);		// INT1 Interrupt Enable

}
//*****************************************
// INT1 Interrupt
//  Start Bit Falling Edge Sence
// 	for PbM
//*****************************************
ISR (INT1_vect)
{
	tim_10ms_exist_gps1s = 20;
}

//***************************
//  forvqwc
//   ocOFk   M ߂lP
//   ocOFg MȂ ߂lO
//***************************
unsigned char	get_gps_clock_stat(void)
{
	unsigned char	r = 0;

	if((PIND & (1 << PIND0)) == 0){			//forvqwcԂ擾
		r = 1;
	}

	return(r);
}

//*****************************************
//  iQj@abcQ̒l擾
//   cp: ̃|C^[
//  ߂l@擾abcf[^
//  		擾łȂ́@O
//*****************************************
unsigned char	get_BCD_from_str(unsigned char *cp)
{
	unsigned char	uc;
	unsigned char	d;

	uc = *(cp+0);
	if(('0' <= uc) && (uc <= '9')){			// ̎
		d = (uc & 0x0f);
		d <<= 4;
		uc = *(cp+1);
		if(('0' <= uc) && (uc <= '9')){
			d |= (uc & 0x0f);				// get BCD
		}else{
			d = 0xff;
		}
	}else{
		d = 0xff;
	}

	return(d);
}

//*****************************************
// w̃R}iڂj̎̕ÃR}̑O̕܂ł擾
//  cp; Tn߂镶̐擪
//   n: 
//
//  őłPQW܂ŒTB
//  OOOɂȂI
//  擾ł temp_str[128] ɓ
//  ߂l@PȏF擾ł
//  		OF擾łȂ
//*****************************************
unsigned char	get_commma_str(unsigned char *scp, unsigned char tn)
{
	unsigned char	r = 0;
	unsigned char	*tcp;
	unsigned char	n;
	unsigned char	i;
	
	for(n=0,i=0; i < 128; i++,scp++){
		if(*scp == 0x00){
			break;
		}else if(*scp == ','){
			n++;
			if(n == tn){
				break;
			}
		}
	}

	if(n == tn){					// w̃R}
		scp++;
		tcp = &temp_str[0];
		*tcp = 0x00;
		for(r=0 ; i<128;i++,scp++,tcp++,r++){
			if(*scp == 0x00){
				break;
			}else if(*scp == ','){
				break;
			}else{
				*tcp = *scp;
				*(tcp+1) = 0x00;
			}
		}
	}

	return(r);
}

//*****************************************
// forf[^NO[oϐɓ
//   forf[^ gps_rx_data[]ɗL
//   ȉ̃O[oϐɓ
//	 gGPS_day;				for ̃f[^ (BCD 1--31)
//	 gGPS_mon;				for ̃f[^ (BCD 1--12j
//	 gGPS_year;				for Ñf[^ (BCD 0--99)
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
unsigned char	get_gps_data_ymd(void)
{
	unsigned char	r = 0;
	unsigned char	uc;
	unsigned char	yd;
	unsigned char	md;
	unsigned char	dd;

	uc = get_commma_str(&gps_rx_data[0],9);				// Xڂ̃R}̎̕ÃR}̑O̕܂ł擾
	if(uc != 0){
		dd = get_BCD_from_str(&temp_str[0]);			//  abcQ̒l(j擾
		if(dd != 0xff){									// Ɏ擾ł
			md = get_BCD_from_str(&temp_str[2]);		//  abcQ̒l(j擾
			if(md != 0xff){								// Ɏ擾ł
				yd = get_BCD_from_str(&temp_str[4]);	//  abcQ̒l(bj擾
				if(yd != 0xff){							// Ɏ擾ł
					gGPS_day  = dd;						// for ̃f[^ (BCD 1--31)
					gGPS_mon  = md;						// for ̃f[^ (BCD 1--12j
					gGPS_year = yd;						// for Ñf[^ (BCD 0--99)
					r = 1;
				}
			}
		}
	}

	return(r);
}
//*****************************************
// forf[^玞bO[oϐɓ
//   forf[^ gps_rx_data[]ɗL
//   ȉ̃O[oϐɓ
//	 gGPS_sec;				for b̃f[^ (BCD 0--59)
//	 gGPS_min;				for ̃f[^ (BCD 0--59)
//	 gGPS_hou;				for ̃f[^ (BCD 0--23j
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
unsigned char	get_gps_data_hms(void)
{
	unsigned char	r = 0;
	unsigned char	uc;
	unsigned char	hd;
	unsigned char	md;
	unsigned char	sd;

	uc = get_commma_str(&gps_rx_data[0],1);				// Pڂ̃R}̎̕ÃR}̑O̕܂ł擾
	if(uc != 0){
		hd = get_BCD_from_str(&temp_str[0]);			//  abcQ̒l(j擾
		if(hd != 0xff){									// Ɏ擾ł
			md = get_BCD_from_str(&temp_str[2]);		//  abcQ̒l(j擾
			if(md != 0xff){								// Ɏ擾ł
				sd = get_BCD_from_str(&temp_str[4]);	//  abcQ̒l(bj擾
				if(sd != 0xff){							// Ɏ擾ł
					gGPS_sec = sd;						// for b̃f[^ (BCD 0--59)
					gGPS_min = md;						// for ̃f[^ (BCD 0--59)
					gGPS_hou = hd;						// for ̃f[^ (BCD 0--23j
					r = 1;
				}
			}
		}
	}

	return(r);
}

//*****************************************
// forf[^̗LO[oϐɓ
//   forf[^ gps_rx_data[]ɗL
//   ȉ̃O[oϐɓ
//   gGPS_data_valid;		forf[^̏ (0:invalid, 1=valid)
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
unsigned char	get_gps_data_valid(void)
{
	unsigned char	r = 0;
	unsigned char	uc;

	uc = get_commma_str(&gps_rx_data[0],2);				// Qڂ̃R}̎̕ÃR}̑O̕܂ł擾
	if(uc != 0){
		if(temp_str[0] == 'A'){
			gGPS_data_valid = 1;
			r = 1;
		}
	}
	return(r);
}

//*****************************************
// forvf[^擾iO[oϐɓj
//   ȉ̃O[oϐ
//	 gGPS_sec;				for b̃f[^ (BCD 0--59)
//	 gGPS_min;				for ̃f[^ (BCD 0--59)
//	 gGPS_hou;				for ̃f[^ (BCD 0--23j
//	 gGPS_day;				for ̃f[^ (BCD 1--31)
//	 gGPS_mon;				for ̃f[^ (BCD 1--12j
//	 gGPS_year;				for Ñf[^ (BCD 0--99)
//   gGPS_data_valid;		forf[^̏ (0:invalid, 1=valid)
//
//   ƂĂforf[^AẮÅ֐̃[v甲ȂB
//   ʐMxXUOOaorȂ̂ŁAf[^͖PrԊuŗ邪A
//   [vPrȏɂȂȂ͂Ȃ́A鎖͏o鎖ɂȂ
//
//   ߂l:@O=O[oϐɓĂȂAPforf[^O[oϐɓꂽ
//*****************************************
#define	WAIT_DOL	0
#define	WAIT_G		1
#define	WAIT_N		2
#define	WAIT_R		3
#define	WAIT_M		4
#define	WAIT_C		5
#define	WAIT_CR		6
#define	WAIT_LF		7
#define	GET_DATA	8

unsigned char	get_gps_clock_data(void)
{
	unsigned char	rr=0;
	unsigned char	r=0;
	unsigned char	rymd=0;
	unsigned char	rhms=0;
	unsigned char	rvalid=0;
	unsigned char	uc=0;
	static unsigned char	proc_stat = 0; // 0:wait'*', 1:wait'G', 2:wait'N', 3:wait'R', 4:wait'M', 5:wait'C', 6;wait 0x0d, 7;wait 0x0a, 8:get GPS data

	r = Get_rxd(&uc);

	if(r == 0){										// Mf[^
		rr = 0;
	}else{											// Mf[^L
		while(1){
			Ggps_data = uc;							// fobOpf[^ɓ
			rr = 0;
			switch(proc_stat){
			 case WAIT_DOL:							// '$'
				if(uc == '$'){						//  '$'̎
					gps_rx_number = 0;				// forMf[^ԍ
					gps_rx_data[gps_rx_number] = uc;
					gps_rx_number++;
					proc_stat = WAIT_G;
				}
				break;
			 case WAIT_G:							// 'G'
				if(uc == 'G'){						//  'G'̎
					gps_rx_data[gps_rx_number] = uc;
					gps_rx_number++;
					proc_stat = WAIT_N;
				}else{								// Ⴄ͓蒼
					proc_stat = WAIT_DOL;
				}
				break;
			 case WAIT_N:							// 'N'
				if(uc == 'N'){						//  'N'̎
					gps_rx_data[gps_rx_number] = uc;
					gps_rx_number++;
					proc_stat = WAIT_R;
				}else{								// Ⴄ͓蒼
					proc_stat = WAIT_DOL;
				}
				break;
			 case WAIT_R:							// 'R'
				if(uc == 'R'){						//  'R'̎
					gps_rx_data[gps_rx_number] = uc;
					gps_rx_number++;
					proc_stat = WAIT_M;
				}else{								// Ⴄ͓蒼
					proc_stat = WAIT_DOL;
				}
				break;
			 case WAIT_M:							// 'M'
				if(uc == 'M'){						//  'M'̎
					gps_rx_data[gps_rx_number] = uc;
					gps_rx_number++;
					proc_stat = WAIT_C;
				}else{								// Ⴄ͓蒼
					proc_stat = WAIT_DOL;
				}
				break;
			 case WAIT_C:							// 'C'
				if(uc == 'C'){						//  'C'̎
					gps_rx_data[gps_rx_number] = uc;
					gps_rx_number++;
					proc_stat = WAIT_CR;
				}else{								// Ⴄ͓蒼
					proc_stat = WAIT_DOL;
				}
				break;
			 case WAIT_CR:							// CR(0x0d)
				gps_rx_data[gps_rx_number] = uc;
				if( gps_rx_number < (GPS_RX_NUMBER_MAX-1)){	// 鎞͏㏑ɂ
					gps_rx_number++;
				}
				if(uc == 0x0d){						//  CR(0x0d)̎
					proc_stat = WAIT_LF;
				}
				break;
			 case WAIT_LF:							// LF(0x0a)
				gps_rx_data[gps_rx_number] = uc;
				if(uc == 0x0a){						//  LF(0x0a)̎
					proc_stat = GET_DATA;
				}else{								// Ⴄ͓蒼
					proc_stat = WAIT_DOL;
				}
				break;
			 case GET_DATA:							// Get Clock data(YMDHMS) from Rxd data
				rhms = get_gps_data_hms();			// forf[^玞bO[oϐɓ
				rvalid = get_gps_data_valid();		// forf[^̗LO[oϐɓ
				rymd = get_gps_data_ymd();			// forf[^NO[oϐɓ
				if ((rymd == 1)||(rhms == 1)){		// ǂ炩̃f[^擾ł
					rr = 1;
				}
				tim_10ms_infrared = 10;				// forvf[^́@M
				proc_stat = WAIT_DOL;
				break;
			 default:
				proc_stat = WAIT_DOL;
				break;
			}
			r = Get_rxd(&uc);						// ̎Mf[^ǂ
			if(r == 0){								// ̎Mf[^
				break;
			}
		}
	}

	return(rr);
}

//*****************************************
// XԐi߂
// ͈ȉɂ
//	gGPS_hou		̃f[^ (BCD 0--23)
//	gGPS_day		̃f[^ (BCD 1--31)
//	gGPS_mon		̃f[^ (BCD 1--12)
//	gGPS_year		Ñf[^ (BCD 0--99)
//*****************************************
void	clock_add_9hour(void)
{
	unsigned char	uru=0;
	unsigned char	syo=0;
	unsigned char	bin=0;
	unsigned char	ad=0;

	if(((((gGPS_year/16)*10)+(gGPS_year/16))%4) == 0){	// 邤N
		uru=1;
	}
	if((gGPS_mon == 0x04)||(gGPS_mon == 0x06)||(gGPS_mon == 0x09)||(gGPS_mon == 0x11)){	// ̌
		syo=1;
	}

//  hour
	bin  = gGPS_hou & 0x0f;
	bin += ((gGPS_hou/16)*10);			// oCi[f[^
	bin += 9;
	if(bin <= 23){
		ad = 0;
	}else{
		bin -= 24;
		ad = 1;
	}
	gGPS_hou = (bin/10);
	gGPS_hou <<= 4;
	gGPS_hou += (bin%10);

	if(ad == 1){
//  day
		bin  = gGPS_day & 0x0f;
		bin += ((gGPS_day/16)*10);			// oCi[f[^
		bin++;
		if(syo == 1){						// ̌
			if(bin <= 30){
				ad = 0;
			}else{
				bin -= 30;
				ad = 1;
			}
		}else if(bin == 2){
			if(uru == 1){					// Q 邤N
				if(bin <= 29){
					ad = 0;
				}else{
					bin -= 29;
					ad = 1;
				}
			}else{							// Q N
				if(bin <= 28){
					ad = 0;
				}else{
					bin -= 28;
					ad = 1;
				}
			}
		}else{								// ̌
			if(bin <= 31){
				ad = 0;
			}else{
				bin -= 31;
				ad = 1;
			}
		}
		gGPS_day = (bin/10);
		gGPS_day <<= 4;
		gGPS_day += (bin%10);
	}

	if(ad == 1){
//  month
		bin  = gGPS_mon & 0x0f;
		bin += ((gGPS_mon/16)*10);			// oCi[f[^
		bin++;
		if(bin <= 12){
			ad = 0;
		}else{
			bin -= 12;
			ad = 1;
		}
		gGPS_mon = (bin/10);
		gGPS_mon <<= 4;
		gGPS_mon += (bin%10);
	}

	if(ad == 1){
// N year
		bin  = gGPS_year & 0x0f;
		bin += ((gGPS_year/16)*10);			// oCi[f[^
		bin++;
		if(bin <= 99){
			ad = 0;
		}else{
			bin -= 100;
		}
		gGPS_year = (bin/10);
		gGPS_year <<= 4;
		gGPS_year += (bin%10);
	}
}
#if	0
//*****************************************
// forŎv킹
// ߂l@OFv킹sȂB
// @@@@PFv킹I
//*****************************************
unsigned char	proc_set_6keta_by_GPS(void)
{
	unsigned char	ye_ho = 0;
	unsigned char	mo_mi = 0;
	unsigned char	da_se = 0;
	unsigned char	sec = 0;				// \Ăb̃f[^ (BCD 0--59)
	unsigned char	min = 0;				// \Ă镪̃f[^ (BCD 0--59)
	unsigned char	hou = 0;				// \Ă鎞̃f[^ (BCD 0--23j
	unsigned char	day = 0;				// \Ẵf[^ (BCD 1--31)
	unsigned char	mon = 0;				// \Ă錎̃f[^ (BCD 1--12j
	unsigned char	yer = 0;				// \ĂÑf[^ (BCD 0--99)
	unsigned char	b_sec = 0;				// \Ăb̃f[^ (BCD 0--59)
	unsigned char	b_min = 0;				// \Ă镪̃oCi[f[^
	unsigned char	b_hou = 0;				// \Ă鎞̃oCi[f[^
	unsigned char	b_day = 0;				// \ẴoCi[f[^
	unsigned char	b_mon = 0;				// \Ă錎̃oCi[f[^
	unsigned char	b_yer = 0;				// \ĂÑoCi[f[^
	unsigned char	data_valid = 0;			// \Ăf[^̂̏ (0:invalid, 1=valid)

	unsigned short	us;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	youbi_nagare = 0;
	unsigned char	disp_ymd = 0;
	unsigned char	disp_req = 1;

	uart_restart();								// UART0 ̎擾ĊJ

	gGPS_sec = 0;									// for b̃f[^ (BCD 0--59)
	gGPS_min = 0;									// for ̃f[^ (BCD 0--59)
	gGPS_hou = 0;									// for ̃f[^ (BCD 0--23j
	gGPS_day = 0;									// for ̃f[^ (BCD 1--31)
	gGPS_mon = 0;									// for ̃f[^ (BCD 1--12j
	gGPS_year= 0;									// for Ñf[^ (BCD 0--99)

	tim_10ms_blink = 0;								// _
	check_sig_init();								// ****** for Check Port-D Bit1 : Output
	while(1){
		check_sig_on();								// ****** for Check Signal High
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}
		check_sog_off();							// ****** for Check Signal Low

		if(tim_10ms_blink == 0){					// _Ń^C~O̎ij\j
			tim_10ms_blink = 25;

			disp_dynamic_day_of_week(youbi_nagare);	// Nixie j\i_Ci~bN_j
			if(disp_ymd == 0){
				if(0 == youbi_nagare){
					youbi_nagare = 6;
				}else{
					youbi_nagare--;
				}
			}else{
				if(6 == youbi_nagare){
					youbi_nagare = 0;
				}else{
					youbi_nagare++;
				}
			}
		}


		if(disp_req == 1){
			disp_req = 0;
			if(disp_ymd == 0){
				da_se = sec;					// for b̃f[^ (BCD 0--59)
				mo_mi = min;					// for ̃f[^ (BCD 0--59)
				ye_ho = hou;					// for ̃f[^ (BCD 0--23j
			}else{
				da_se = day;					// for ̃f[^ (BCD 1--31)
				mo_mi = mon;					// for ̃f[^ (BCD 1--12j
				ye_ho = yer;					// for Ñf[^ (BCD 0--99)
			}
			disp_nixie_tow(0,ye_ho);			// N- \
			disp_nixie_tow(2,mo_mi);			// - \
			disp_nixie_tow(4,da_se);			// -b \
			if(data_valid == 0){				// ̎
				disp_dynamic_dotl_on_off(0);	// hbg@
				disp_dynamic_dotr_on_off(0);	// Ehbg@
			}else{
				disp_dynamic_dotl_on_off(1);	// hbg@_
				disp_dynamic_dotr_on_off(1);	// Ehbg@_
			}
		}
		

		if(us != 0){									// ANVL鎞
			proc_no_key_timeup(1);						// L[͂L
			if((us & SW1_OFF_LONG) != 0){				// ꎞ(set switch)
				b_sec = gGPS_sec & 0x0f;
				b_sec += ((gGPS_sec/16)*10);			// boCi[f[^
				b_min = gGPS_min & 0x0f;
				b_min += ((gGPS_min/16)*10);			// oCi[f[^
				b_hou = gGPS_hou & 0x0f;
				b_hou += ((gGPS_hou/16)*10);			// oCi[f[^
				b_day = gGPS_day & 0x0f;
				b_day += ((gGPS_day/16)*10);			// oCi[f[^
				b_mon = gGPS_mon & 0x0f;
				b_mon += ((gGPS_mon/16)*10);			// oCi[f[^
				b_yer = gGPS_year & 0x0f;
				b_yer += ((gGPS_year/16)*10);			// NoCi[f[^
				if((b_sec<60) && (b_min<60) && (b_hou<24) && ((0<b_day)&&(b_day<32)) && ((0<b_mon)&&(b_mon<13))){		// vf[^Ȏ
					clock_add_9hour();					// XԐi߂
					gRTC_sec = gGPS_sec;				// for b̃f[^ (BCD 0--59)
					gRTC_min = gGPS_min;				// for ̃f[^ (BCD 0--59)
					gRTC_hou = gGPS_hou;				// for ̃f[^ (BCD 0--23)
					gRTC_day = gGPS_day;				// for ̃f[^ (BCD 1--31)
					gRTC_mon = gGPS_mon;				// for ̃f[^ (BCD 1--12)
					gRTC_year =gGPS_year;				// for Ñf[^ (BCD 0--99)
					gRTC_wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					gRTC_wday++;
					rtc_write();						// RTC 
					r = 1;								// ݒIɂ
					break;								// I
				}
			}else if((us & SW2_OFF_LONG) != 0){			// ꎞ(select switch)
					r = 0;								// 蓮ݒs
					break;								// I
			}else if((us & SW2_OFF_SHORT) != 0){		// ꎞ(select switch)
				if(disp_ymd == 0){
					disp_ymd = 1;
				}else{
					disp_ymd = 0;
				}
				disp_req = 1;
			}
		}

		uc = get_gps_clock_data();			// forvf[^擾iO[oϐɓj
		if(uc != 0){
			sec = gGPS_sec;					// for b̃f[^ (BCD 0--59)
			min = gGPS_min;					// for ̃f[^ (BCD 0--59)
			hou = gGPS_hou;					// for ̃f[^ (BCD 0--23j
			day = gGPS_day;					// for ̃f[^ (BCD 1--31)
			mon = gGPS_mon;					// for ̃f[^ (BCD 1--12j
			yer = gGPS_year;				// for Ñf[^ (BCD 0--99)
			data_valid = gGPS_data_valid;	// forf[^̏ (0:invalid, 1=valid)
			disp_req = 1;
		}

		if((tim_10ms_infrared != 0)){		// forvf[^́@M̎
			led_ds3_on();					// LED(DS3) ON
		}else{
			led_ds3_off();					// LED(DS3) OFF
		}

		if((tim_10ms_uart != 0)){			// t`qsɐMiG[̗LAf[^̓eɂ͖֌Wj
			led_ds2_on();					// LED(DS2) ON
		}else{
			led_ds2_off();					// LED(DS2) OFF
		}

	}

	uart_pause();						// UART0 ̎擾߂

	return(r);
}
#endif
