//*****************************************
// AVR ATmega328 8x8 LED Clock
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:pr_mega328_8x8dot_clocl.c
//@ pro_fifteen_in17_clock ̃vWFNgRs[ā@pro_fourteen_in172_clock@ɂ킹B
//
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/01 Modify for pr_mega1284_8x8dot_clock Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega328_8x8dot_clock_h.h"
#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"display_h.h"
#include	"dot8x8_h.h"
//#include	"rtc_ds3234_h.h"
//#include	"set_rtc_h.h"
#include	"eep_dat_h.h"
#include	"uart_h.h"
#include	"infrared_h.h"
#include	"gps_clock_h.h"

unsigned char			g_keta;

static	unsigned char	run=0;


//***************************
// `FbNiX^eBbN\js
//  kdcPRx_ł
//  e̐\Ă鎞 XCb`閈ɂO`XԂɕ\
//  XCb` \錅ړB ԍ珇ԂŁAŌオŘŁA͈ԍɖ߂
//***************************
void	check_static(void)
{
	unsigned short	us;
	unsigned char	kazu = 0;
//	unsigned char	keta = 5;
	unsigned char	keta = 4;						// 20221010
	unsigned char	req_disp = 0;
	unsigned char	old_keta = 1;

	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF

	get_sw();

	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

//	keta = 5;
	keta = 4;										// 20221010
	kazu = 0;
	disp_dot8x8_number(keta+1, 15);					// 
	disp_dot8x8_number(keta+2, 15);					// 
	disp_dot8x8_number(keta+3, 15);					// 
	disp_dot8x8_number(keta+4, 15);					// 
	disp_dot8x8_number(keta+5, 15);					// 20221010 

	disp_dot8x8_number(keta, kazu);					// 
	old_keta = keta;
	led5_off();										// LED1 OFF
	req_disp = 1;									// \vnm

	for(;;){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}

		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if((us == SW2_OFF_SHORT)||(us == SW2_OFF_LONG)){		// XCb`NbNꂽ(select switch)
			kazu++;
			if(9 < kazu){
				kazu = 0;
			}
			disp_dot8x8_number(keta, kazu);						// 
			req_disp = 1;										// \vnm
		}

		if((us == SW1_OFF_SHORT)||(us == SW1_OFF_LONG)){		// XCb`NbNꂽ(set switch)
			keta++;
			if(KETA_MAX <= keta){
//				keta = 5;
				keta = 4;										// 20221010
			}
			disp_dot8x8_number(old_keta, 15);					// Ǒ̐
			disp_dot8x8_number(keta, kazu);						// 
			old_keta = keta;
			req_disp = 1;										// \vnm
		}
	}

}
//***************************
// `FbNi_Ci~bN\js
//  kdcPAQQx_ł
//  XCb`ėꂽ eO`XAĕ\iPbԊuŕ\ωj
//***************************
void	check_dynamic(void)
{
	unsigned short	us;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
//	unsigned char	keta = 5;
	unsigned char	keta = 4;						// 20221010
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;
	unsigned char	req_disp = 0;

	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	led5_off();										// LED1 OFF
	disp_dot8x8_clear();							// \S 
	req_disp = 1;									// \vnm

	for(;;){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}

		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW2_OFF_SHORT){								// XCb`Zėꂽ(select switch)
			pause ^= 1;											// ړ\𒆒f or Jn
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;								// 1000mS Ԋu
			if(pause == 0){
				if(old_keta != keta){							// ς
					disp_dot8x8_number(old_keta, 15);			// Ǒ̐
					old_keta = keta;
					req_disp = 1;								// \vnm
				}
				disp_dot8x8_number(keta, kazu);					// 
				req_disp = 1;									// \vnm

				kazu++;
				if(9 < kazu){									// \XȏɂȂ
					kazu = 0;									// Oɖ߂
					keta++;
					if(KETA_MAX <= keta){						// \߂
//						keta = 5;
						keta = 4;								// 20221010
					}
				}
			}
		}
	}

}

//***************************
// ␳aorUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQUOO
//***************************
unsigned short calc_bps600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}

#if	0
//***************************
// aorUOO̒l`FbN
//  kdcSx_ł
//  XCb`ėꂽ 
//@^C}[P̒lŏʂɂS\BiWlg҂ȂVWPRj
//@aorUOO̒lŉʂRɕ\BiWlg҂ȂWRRj
//@qsb̂PbM̃^C~OŃ^C}[P̒lƂaorUOO̒lXV
//  rdsXCb`Zꂽ@݂̂aorUOO
//  @aorUOO̒lɏ݁AȌケ̒lg
//
//  ̂aorUOÕ`FbNvÓ@̂WW@ł
//    O̐Uqĝŕsv
//    ͌Ă΂Ȃ
//***************************
void	check_bps600(void)
{
	unsigned short	us;
	unsigned short	t1_count = 7813;
	unsigned short	bps600 = 833;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	req_disp = 0;					// \v

	bps600 = gBPS_600;

	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF

	get_sw();

	timer1_init();									// Timer1 Initial
	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	led5_off();										// LED1 OFF
	disp_dot8x8_clear();							// \S
	disp_dot8x8_4binary(6,bps600);					// S\iXXXX܂Łj
	delay_ms(1000);									// 1S Delay
	req_disp = 1;									// \vnm

	// ŏ̈͒l肵Ȃ̂ŃX[
	for(;;){
		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			break;
		}
	}
	for(;;){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW1_OFF_SHORT){								// XCb`Zėꂽ(set switch)
			write_eep_bps_600(bps600);							//@ddoqnl BPS_600 
			write_eep_bps_9600(((bps600+1)/16)-1);				//@ddoqnl BPS_9600 
		}

		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			t1_count = TCNT1;									// sbmsPǂݏo
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			bps600 = calc_bps600(t1_count);						// ␳aorUOOvZ
			disp_dot8x8_4binary(6,bps600);						// S\iXXXX܂Łj
			req_disp = 1;										// \vnm
		}
	}

}
#endif

//***************************
// wԍɂā@kdc_
//     LED1  LED2  LED3
// n=0: ON    OFF   OFF
// n=1: ON    ON    OFF
// n=2: ON    OFF   ON 
// n=3: ON    ON    ON 
//
// @͂O`R
//***************************
static
void	disp_led23(unsigned char n)
{
	switch(n){
		case 0:
		 led5_on();				// LED1 ON
		 break;

		case 1:
		 led5_on();				// LED1 ON
		 break;

		case 2:
		 led5_on();				// LED1 ON
		 break;

		case 3:
		 led5_on();				// LED1 ON
		 break;

		default:
			;					// Ȃ
	}
}
//***************************
// WWhbg̐ݒaorƐݒʒu`FbN
//  kdcPCQCRSx_łAXCb`܂œ_
//  XCb`ėꂽ kdcPCQCR͏
//@݂̂WW kdc i̊j̐ݒaor̍ŏʂ̐SMAkdc
//@@iuXUOOvȂuXvPO\Ł@kdcP̂ݓ_j
//@rdkdbsXCb`閈Ɂ@MaorωĂ̍ŏʂ̐SM
//@@ω鏇Ԃ 9600(LED1) --> 4800(LED1,2) --> 2400(LED1,3) --> 1200(LED1,2,3) --> 9600(LED1) ̏z
//@rdsXCb`iQbȏjƁ@̎̑Maor̊̑MݒaorƂĂɏ
//@@ā@̑MaorŁu0123456789+cr+lfv𑗐MB
//@@rdkdbsXCb`閈Ɂ@u0123456789+cr+lfv̑MJԂB
//@@̑M^C~OŁ@MaorɑΉkdcœ_ł
//@̃[`甲鎖͖̂Ł@I肽́@qdrdsXCb`Ad؂
//***************************

// MaorƑMaoȓM@̓͓т̕KvL
static	unsigned short	bps_tx[4]  ={ BPS_9600, BPS_4800, BPS_2400, BPS_1200};		// Maor
static	unsigned char	bps_char[4]={    '9',      '4',      '2',      '1'  };		// MaoȓM
void	check_8x8dot(void)
{
	unsigned char	uc;
	unsigned char	bps_no = 0;
	unsigned char	req_disp = 0;					// \v
	unsigned short	bps_data = BPS_9600;
	unsigned short	us;

	led5_on();										// LED1 ON
	delay_ms(500);									// 500mS Delay
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF
	delay_ms(500);									// 500mS Delay
	led5_on();										// LED1 ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led5_off();										// LED1 OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	sei();											// 荞݉
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay

	led5_off();										// LED1 OFF

	// MaorT
	bps_data = read_eep_bps_9600();					// EEPROM  BPS_uart ǂݍ
	for(bps_no = 0; bps_no < 4; bps_no++){
		if(bps_data == bps_tx[bps_no]){				// ̂Ŕ
			break;
		}
	}
	if(bps_no <= 3){								// 
		;
	}else{											// Ȃ
		bps_no = 0;									// ftHg
		bps_data = bps_tx[bps_no];					// XUOOɂ
		write_eep_bps_9600(bps_tx[bps_no]);		// eeprom  Maor 
	}

	for(uc = 0; uc < 10; uc++){
		disp_dot8x8_moji(uc, bps_char[bps_no]);		// aor̍ŏʐőS߂
	}
	uart_close();									// x UART Close
	delay_ms(100);									// Ƒ҂
	uart_init();									// ēx UART Initial

	req_disp = 1;										// \vnm

	for(;;){
		if(req_disp == 1){								// \vnm̎
			disp_led23(bps_no);							// wԍɂā@kdc_
			tim_10ms_blink = 20;						// kdc_
			disp_dot8x8_all();							// WW S\
			req_disp = 0;								// \vnee
		}
		us = get_action_sw();							// XCb`Ԃ
		us &= SW_MASK;									// XCb`ɂ

		if(us == SW1_OFF_LONG){							// XCb`Zėꂽ(set switch)
			write_eep_bps_9600(bps_tx[bps_no]);		// eeprom  ̑Maor 
			break;
//		}else if((us == SW2_OFF_LONG)||(us == SW2_OFF_SHORT)){	// XCb`ėꂽ(select switch)
//			for(uc = 0; uc < 10; uc++){
//				disp_dot8x8_moji(uc, 15);				// SXy[XŖ߂
//			}
//			disp_dot8x8_all();							// WW S\
//			delay_ms(50);								// Ƒ҂
//			bps_no++;									// ɂ
//			if(3 < bps_no){
//				bps_no = 0;
//			}
//			uart1_change_bps(bps_tx[bps_no]);			// aorύX
//			for(uc = 0; uc < 10; uc++){
//				disp_dot8x8_moji(uc, bps_char[bps_no]);	// aor̍ŏʐőS߂
//			}
//			req_disp = 1;								// \vnm
		}

	}

	for(uc=0;uc<10;uc++){
		disp_dot8x8_number(uc, uc);						// 
	}
	req_disp = 1;										// \vnm

	for(;;){
		if(req_disp == 1){								// \vnm̎
			led5_off();									// LED5 OFF
			tim_10ms_blink = 20;						// kdc_
			disp_dot8x8_all();							// WW S\
			req_disp = 0;								// \vnee
		}

		us = get_action_sw();							// XCb`Ԃ
		us &= SW_MASK;									// XCb`ɂ

		if((us == SW2_OFF_LONG)||(us == SW2_OFF_SHORT)){	// XCb`ėꂽ(select switch)
			req_disp = 1;								// \vnm
		}

		if(tim_10ms_blink == 0){						// kdc_ԃ^CAbv
			disp_led23(bps_no);							// wԍɂā@kdc_
		}

	}

}

//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_keta = 4;		// 20221010  4--9
	static	unsigned char	ani_kazu = 0;		// l 0--9
	unsigned char			r = 0;

	if (init == 1){
		ani_keta = 4;							// 20221010
		ani_kazu = 0;
	}else{
		if(ani_kazu == 0){
			disp_dot8x8_number(4, 15);					// 20221010 
			disp_dot8x8_number(5, 15);					// 
			disp_dot8x8_number(6, 15);					// 
			disp_dot8x8_number(7, 15);					// 
			disp_dot8x8_number(8, 15);					// 
			disp_dot8x8_number(9, 15);					// 
			ani_kazu = 0;
		}

		disp_dot8x8_number(ani_keta, ani_kazu);
		disp_dot8x8_all();									// WW S\

		ani_kazu++;
		if(9 < ani_kazu){
			ani_kazu = 0;
			ani_keta++;										// ̌
			if(9 < ani_keta){
				ani_keta = 4;								// 20221010
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
// ԊORf[^XCb`f[^ɕϊ
//***************************
unsigned short	trans_if_to_sw(unsigned char if_data)
{
	unsigned short	us = 0;
	static unsigned short	sw_stat = 0;

	switch(if_data){
	 case IND1_ON_NOW:			// set n߂
		us = SW1_ON_NOW;
		sw_stat |= SW1_ON;
		break;
	 case IND1_ON_CONTINUE:		// set A
		us = SW1_ON_CONTINUE;
		break;
	 case IND1_OFF_SHORT:		// set Zė
		us = SW1_OFF_SHORT;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND1_OFF_LONG:		// set ė
		us = SW1_OFF_LONG;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND2_ON_NOW:			// select n߂
		us = SW2_ON_NOW;
		sw_stat |= SW2_ON;
		break;
	 case IND2_ON_CONTINUE:		// select A
		us = SW2_ON_CONTINUE;
		break;
	 case IND2_OFF_SHORT:		// select Zė
		us = SW2_OFF_SHORT;
		sw_stat &= ~(SW2_ON);
		break;
	 case IND2_OFF_LONG:		// select ė
		us = SW2_OFF_LONG;
		sw_stat &= ~(SW2_ON);
		break;
	}

	us |= sw_stat;
	return(us);
}

#if	0
//***************************
//  TiS{Rj p Main
// 20221010  Uij{S{Rj p Main
//***************************
static	void	main_5_keta(void)
{
	unsigned short	us;
//	unsigned char	ucinf;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_sec = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned char	req_disp = 0;					// \v

	led5_on();										//  red LED ON

	sei();											// 荞݉

	disp_dot8x8_number(4, 15);						// 20221010 
	disp_dot8x8_4binary(6,VER_DATA);				// o[WS\iXXXX܂Łj
	if(VER_DATA/1000 == 0){
		disp_dot8x8_number(5, 15);					// 20221010 
		disp_dot8x8_moji(6, 'V');					// 20221010
	}
	disp_dot8x8_all();								// WW S\

	delay_ms(2000);									// 2000mS Delay
	led5_off();										//  red LED OFF

//	disp_dot8x8_moji(5,'B');						// 
//	disp_dot8x8_4binary(6,gBPS_600);				// aorUOO@S\iXXXX܂Łj
//	disp_dot8x8_all();								// WW S\

//	delay_ms(2000);									// 2000mS Delay
	//led2_off();										//  yellow LED OFF

	disp_dot8x8_moji(5,'b');						// 
	disp_dot8x8_4binary(6,gBPS_9600);				// aorXUOO@S\iXXXX܂Łj
	disp_dot8x8_all();								// WW S\

	delay_ms(2000);									// 2000mS Delay

	tim_10ms_anime = 100;

	req_disp = 0;									// \vnm

	while(1){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
//		ucinf = get_infrared_data();							// ԊORfqf[^
//		if(us == 0){											// XCb`ĂȂ
//			us = trans_if_to_sw(ucinf);							// ԊORf[^XCb`f[^ɕϊ
//		}

		if(us == SW1_OFF_LONG){									// ꂽ(set switch)
//			proc_no_key_timeup(1);								// L[͂L
//			disp_clock_mode = SET;
//			proc_set_rtc();										// v킹
//			disp_clock_mode = HM;
//			old_RTC_year = 0xff;
//			old_RTC_mon = 0xff;
//			old_RTC_day = 0xff;
//			old_RTC_hou = 0xff;
//			old_RTC_min = 0xff;
//			old_RTC_sec = 0xff;
//			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case YE:
				disp_clock_mode = TEMPER;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case TEMPER:
				disp_clock_mode = HM;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();										// RTC ǂݏo
				tim_10ms_blink = 50;
				if(disp_clock_mode == YE){						// N[h
					tim_10ms_anime = 50;
					if(old_RTC_year != gRTC_year){				// Nω
						disp_dot8x8_moji(4, (0x10 + gRTC_wday - 1));		// 20221010 j\
						disp_dot8x8_number(5, 15);				// 
						disp_dot8x8_tow(6,0x20);				// NiQOj \
						disp_dot8x8_tow(8,gRTC_year);			// N \
						old_RTC_year = gRTC_year;
						req_disp = 1;							// \vnm
					}
				}else if(disp_clock_mode == MD){				// [h
					if(old_RTC_mon != gRTC_mon){				// ω
						disp_dot8x8_moji(4, (0x10 + gRTC_wday - 1));		// 20221010 j\
						disp_dot8x8_tow(5,gRTC_mon);			//  \
						old_RTC_mon = gRTC_mon;
						disp_dot8x8_moji(7,'-');				// 
						req_disp = 1;							// \vnm
					}
					if(old_RTC_day != gRTC_day){				// ω
						disp_dot8x8_moji(4, (0x10 + gRTC_wday - 1));		// 20221010 j\
						disp_dot8x8_tow(8,gRTC_day);			//  \
						old_RTC_day = gRTC_day;
						disp_dot8x8_moji(7,'-');				// 
						req_disp = 1;							// \vnm
					}
				}else if(disp_clock_mode == HM){				// [h
					if(old_RTC_hou != gRTC_hou){				// ω
						disp_dot8x8_moji(4, (0x10 + gRTC_wday - 1));		// 20221010 j\
						disp_dot8x8_tow(5,gRTC_hou);			//  \
						old_RTC_hou = gRTC_hou;
						disp_dot8x8_moji(7,':');				// 
						req_disp = 1;							// \vnm
					}
					if(old_RTC_min != gRTC_min){				// ω
						disp_dot8x8_moji(4, (0x10 + gRTC_wday - 1));		// 20221010 j\
						disp_dot8x8_tow(8,gRTC_min);			//  \
						old_RTC_min = gRTC_min;
						disp_dot8x8_moji(7,':');				// 
						req_disp = 1;							// \vnm
					}

					if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
						old_disp_clock_mode = disp_clock_mode;
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
					}

				}else if(disp_clock_mode == TEMPER){			// x\[h̎
					temperature_read();							// xǂݏo
					disp_dot8x8_number(4, 15);					// 20221010 
					disp_dot8x8_moji(5,'T');					// 'T'
					disp_dot8x8_4binary(6,gTemperature);		// S\iXXXX܂Łj
					req_disp = 1;								// \vnm
				}else if(disp_clock_mode == Infr_Data){			// ԊOMf[^[h̎
					disp_dot8x8_number(4, 15);					// 20221010 
					disp_dot8x8_moji(5,'I');					// 'I'
					disp_dot8x8_4binary(6,Ginf_data);			// S\iXXXX܂Łj
					req_disp = 1;								// \vnm
				}

			}

			if (proc_no_key_timeup(0) == 0xff){						// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
					old_RTC_year = 0xff;
					old_RTC_mon = 0xff;
					old_RTC_day = 0xff;
					old_RTC_hou = 0xff;
					old_RTC_min = 0xff;
					old_RTC_sec = 0xff;
				}
			}

			if(tim_10ms_anime == 0){							// TOO
				if(disp_clock_mode == ANIME){					// Aj[V̎
					tim_10ms_anime = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_year = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
						old_RTC_sec = 0xff;
					}
				}
			}
		}

	}
}
#endif

//***************************
//  Uij{S{Rj p Main
//   forf[^g
//***************************
static	void	main_6_keta_gps(void)
{
	unsigned short	us;
	unsigned char	ucinf;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_GPS_sec = 0xff;
	unsigned char	old_GPS_min = 0xff;
	unsigned char	old_GPS_hou = 0xff;
	unsigned char	old_GPS_mon = 0xff;
	unsigned char	old_GPS_day = 0xff;
	unsigned char	old_GPS_year = 0xff;
	unsigned char	req_disp = 0;					// \v
	unsigned char	uc = 0;
	unsigned char	gps_wday = 0;					// j(0-->6)
	unsigned char	exist_gps = 0;					// forL (0: ,1:L)
	unsigned char	disp_gps_moji = 0;
	unsigned char	req_gps_data_set = 0;

	gps_clock_init();								// forv Initial
	gps_1sec_init();								// for PbMݐݒ

	led5_on();										// red LED ON

	uart_pause();									// UART0 ̎擾߂

	sei();											// 荞݉

	disp_dot8x8_number(4, 15);						// 
	disp_dot8x8_4binary(6,VER_DATA);				// o[WS\iXXXX܂Łj
	if(VER_DATA/1000 == 0){
		disp_dot8x8_number(5, 15);					// 
		disp_dot8x8_moji(6, 'V');
	}
	disp_dot8x8_all();								// WW S\

	delay_ms(2000);									// 2000mS Delay
	led5_off();										// red LED OFF

	disp_dot8x8_moji(5,'b');						// 
	disp_dot8x8_4binary(6,gBPS_9600);				// aorXUOO@S\iXXXX܂Łj
	disp_dot8x8_all();								// WW S\

	delay_ms(2000);									// 2000mS Delay

	tim_10ms_anime = 100;

	exist_gps = 0;									// forƂ
	tim_1s_no_gps = 0;								// forf[^̗P\^CAbvp 60sec
	tim_10ms_blink = 50;
	disp_gps_moji = 0;
	req_disp = 0;									// \vnm
	ucinf = 0;

	uart_restart();									// UART ̎擾ĊJ

	while(1){
		if(req_disp == 1){										// \vnm̎
			disp_dot8x8_all();									// WW S\
			req_disp = 0;										// \vnee
		}
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
//		ucinf = get_infrared_data();							// ԊORfqf[^
//		if(us == 0){											// XCb`ĂȂ
//			us = trans_if_to_sw(ucinf);							// ԊORf[^XCb`f[^ɕϊ
//		}

		if(us == SW1_OFF_LONG){									// ꂽ(set switch)
			;													// forf[^ĝŐݒ͖
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			 case YE:
				disp_clock_mode = HM;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_GPS_year = 0xff;
				old_GPS_mon = 0xff;
				old_GPS_day = 0xff;
				old_GPS_hou = 0xff;
				old_GPS_min = 0xff;
				old_GPS_sec = 0xff;
				break;
			}
			req_gps_data_set = 1;							// \f[^̃Zbgvnm
		}else{
			uc = get_gps_clock_data();							// forvf[^擾iO[oϐɓj
			if(uc != 0){										// forf[^
				exist_gps = 1;									// forL
				tim_1s_no_gps = 60;								// forf[^̗P\^CAbvp 60sec
				clock_add_9hour();								// XԐi߂
				gps_wday = subZeller((2000+((gGPS_year >> 4)*10)+(gGPS_year & 0x0f)), (((gGPS_mon >> 4)*10)+(gGPS_mon & 0x0f)), (((gGPS_day >> 4)*10)+(gGPS_day & 0x0f)) );	// cF[̌
				tim_10ms_blink = 50;
				req_gps_data_set = 1;							// \f[^̃Zbgvnm
			}else{
				if(exist_gps == 0){								// for
					if(tim_10ms_blink == 0){
						tim_10ms_blink = 50;
						disp_gps_moji ^= 1;
					}
					if(disp_gps_moji == 1){
						disp_dot8x8_moji(5,'-');					// 
						disp_dot8x8_moji(6,'G');					// 
						disp_dot8x8_moji(7,'P');					// 
						disp_dot8x8_moji(8,'S');					// 
						disp_dot8x8_moji(9,'-');					// 
					}else{
						disp_dot8x8_moji(5,' ');					// 
						disp_dot8x8_moji(6,' ');					// 
						disp_dot8x8_moji(7,' ');					// 
						disp_dot8x8_moji(8,' ');					// 
						disp_dot8x8_moji(9,' ');					// 
					}
					req_disp = 1;									// \vnm
				}
			}

			if(req_gps_data_set != 0){							// forf[^̃ZbgvL̎nm
				req_gps_data_set = 0;
				if(disp_clock_mode == YE){						// N[h
					tim_10ms_anime = 50;
					if(old_GPS_year != gGPS_year){				// Nω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_number(5, 15);				// 
						disp_dot8x8_tow(6,0x20);				// NiQOj \
						disp_dot8x8_tow(8,gGPS_year);			// N \
						old_GPS_year = gGPS_year;
						req_disp = 1;							// \vnm
					}
				}else if(disp_clock_mode == MD){				// [h
					if(old_GPS_mon != gGPS_mon){				// ω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_tow(5,gGPS_mon);			//  \
						old_GPS_mon = gGPS_mon;
						disp_dot8x8_moji(7,'-');				// 
						req_disp = 1;							// \vnm
					}
					if(old_GPS_day != gGPS_day){				// ω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_tow(8,gGPS_day);			//  \
						old_GPS_day = gGPS_day;
						disp_dot8x8_moji(7,'-');				// 
						req_disp = 1;							// \vnm
					}
				}else if(disp_clock_mode == HM){				// [h
					if(old_GPS_hou != gGPS_hou){				// ω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// j\
						disp_dot8x8_tow(5,gGPS_hou);			//  \
						old_GPS_hou = gGPS_hou;
						disp_dot8x8_moji(7,':');				// 
						req_disp = 1;							// \vnm
					}
					if(old_GPS_min != gGPS_min){				// ω
						disp_dot8x8_moji(4, (0x10 + gps_wday));	// 20221010 j\
						disp_dot8x8_tow(8,gGPS_min);			//  \
						old_GPS_min = gGPS_min;
						disp_dot8x8_moji(7,':');				// 
						req_disp = 1;							// \vnm
					}

					if((gGPS_min == 0)&&(gGPS_sec == 0)){		// ̎
						old_disp_clock_mode = disp_clock_mode;
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
					}

				}else if(disp_clock_mode == Infr_Data){			// ԊOMf[^[h̎
					disp_dot8x8_number(4, 15);					// 
					disp_dot8x8_moji(5,'I');					// 'I'
					disp_dot8x8_4binary(6,Ginf_data);			// S\iXXXX܂Łj
					req_disp = 1;								// \vnm
				}
			}

			if(exist_gps != 0){										// forL
				if(tim_1s_no_gps == 0){								// forf[^P\^CAbv
					exist_gps = 0;									// forƂ
				}
			}


			if (proc_no_key_timeup(0) == 0xff){						// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
					old_GPS_year = 0xff;
					old_GPS_mon = 0xff;
					old_GPS_day = 0xff;
					old_GPS_hou = 0xff;
					old_GPS_min = 0xff;
					old_GPS_sec = 0xff;
				}
			}

			if(tim_10ms_anime == 0){							// TOO
				if(disp_clock_mode == ANIME){					// Aj[V̎
					tim_10ms_anime = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_GPS_year = 0xff;
						old_GPS_mon = 0xff;
						old_GPS_day = 0xff;
						old_GPS_hou = 0xff;
						old_GPS_min = 0xff;
						old_GPS_sec = 0xff;
					}
				}
			}
		}

		if(tim_10ms_exist_gps1s != 0){						// forPbԊuMLiforf[^Ԋuj
			led5_on();										// LED5 ON
		}else{
			led5_off();										// LED5 OFF
		}
	}
}

//***************************
//  Main
//***************************
int	main(void)
{
	unsigned char	uc;
//	unsigned short	us;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0)  | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, UART1, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay

	init_dot8x8();									//  8x8 dot\ 
	sw_init();										// XCb`֌W̏ݒ
	led5_init();									// kdcT֌W̏ݒ
	timer2_init();									// Timer2 Initial

//	infrared_init();								// ԊORfq Initial

	g_keta = KETA_MAX;								// KETA = 14

	for(uc=0; uc<10; uc++){							// PO_
		led5_on();									// red LED ON
		delay_ms(500);								// 500mS Delay
		led5_off();									// red LED OFF
		delay_ms(500);								// 500mS Delay
	}

// -- ̂UOOaor̃`FbŃ@OUqgĂ̂ŎgȂ
//	if((PINA & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
//		if((PINA & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
//			check_bps600();							// UOOaor̒l`FbN
//		}
//	}

// -- Ɂ@WWhbg̐ݒaorƐݒʒu𒲂ׂ郋[`
//	if((PINA & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
//		if((PINA & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
//			check_8x8dot();							// WWhbg̐ݒaorƐݒʒu`FbN
//		}
//	}

//	for(;;){
//		if((SW_IN_PORT & SW2_ON_BIT) == 0){				// XCb`f[^Ă(select switch)
//			check_dynamic();							// `FbNi_Ci~bN\js
//			led5_on();									// red LED ON
//		}

//		if((SW_IN_PORT & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
//			check_static();								// `FbNiX^eBbN\js
//			led5_off();									// red LED OFF
//			delay_ms(2000);
//			break;
//		}
//	}

//	for(uc=0; uc<5; uc++){							// PO_
//		led5_on();									// red LED ON
//		delay_ms(250);								// 250mS Delay
//		led5_off();									// red LED OFF
//		delay_ms(250);								// 250mS Delay
//	}

// `FbNp@||||
//	sei();											// 荞݉
//
//	for(uc=0; uc<10; uc++){							// PO_
//		led5_on();									// red LED ON
//		delay_ms(100);								// 100mS Delay
//		led5_off();									// red LED OFF
//		delay_ms(100);								// 100mS Delay
//	}
//
//	tim_10ms_blink=100;								// \uNpPOrPʃ^C}[ 1sec
//	disp_dot8x8_moji(9,'H');						// 'H'
//	disp_dot8x8_all();								// WW S\
//
//	for(;;){
//		if(tim_10ms_blink==0){						// \uNpPOrPʃ^C}[
//			tim_10ms_blink=200;						// \uNpPOrPʃ^C}[ 2sec
//			led5_toggle();
//		}
//		us = get_action_sw();									// XCb`Ԃ
//		us &= SW_MASK;											// XCb`ɂ
//		if(us == SW1_OFF_SHORT){						// Zėꂽ(set switch)
//			led5_off();									// red LED OFF
//			disp_dot8x8_moji(9,'B');					// 'B'
//			disp_dot8x8_all();							// WW S\
//		}
//		if(us == SW2_OFF_SHORT){						// Zėꂽ(select switch)
//			led5_on();									// red LED ON
//			disp_dot8x8_moji(9,'A');					// 'B'
//			disp_dot8x8_all();							// WW S\
//		}
//	}

	main_6_keta_gps();									//  Uij{S{Rj p Main

}
